/*
Copyright Renaud GICQUEL 2005-2006  
renaud.gicquel@ensmp.fr

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/
package extThopt;

import javax.swing.*;
import java.beans.*;
import java.awt.*;
import java.util.*;
import rg.thopt.*;
import java.io.*;

/**
 * Classe pour calculer le bilan nergtique d'un moteur Stirling
 *
 * @author Renaud GICQUEL
 */
public class PiloteStirling extends ExtPilot
{
	boolean isInitialized=false;
	SolarConcentratorCC collector;
	boolean isBuilt=false;
	String[]composant,nomComposant;
    String compressorName="",expansionName="",collectorName="";

	public PiloteStirling()
	{
		//{{INIT_CONTROLS
		setTitle("Stirling driver");
		getContentPane().setLayout(null);
		setSize(671,413);
		setVisible(false);
		JLabel1.setText("compression");
		getContentPane().add(JLabel1);
		JLabel1.setBounds(24,108,156,24);
		getContentPane().add(tauCompr_value);
		tauCompr_value.setBounds(192,108,96,24);
		tauCompr_value.setSelectionColor(new java.awt.Color(204,204,255));
		tauCompr_value.setSelectedTextColor(java.awt.Color.black);
		tauCompr_value.setCaretColor(java.awt.Color.black);
		tauCompr_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		JLabel2.setText("expansion");
		getContentPane().add(JLabel2);
		JLabel2.setBounds(24,144,156,24);
		getContentPane().add(tauExpan_value);
		tauExpan_value.setBounds(192,144,96,24);
		tauExpan_value.setSelectionColor(new java.awt.Color(204,204,255));
		tauExpan_value.setSelectedTextColor(java.awt.Color.black);
		tauExpan_value.setCaretColor(java.awt.Color.black);
		tauExpan_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		JLabel3.setText("net power");
		getContentPane().add(JLabel3);
		JLabel3.setForeground(java.awt.Color.red);
		JLabel3.setBounds(24,252,156,24);
		getContentPane().add(netPower_value);
		netPower_value.setForeground(java.awt.Color.red);
		netPower_value.setBounds(192,252,96,24);
		netPower_value.setSelectionColor(new java.awt.Color(204,204,255));
		netPower_value.setSelectedTextColor(java.awt.Color.black);
		netPower_value.setCaretColor(java.awt.Color.black);
		netPower_value.setDisabledTextColor(java.awt.Color.lightGray);
		JLabel6.setText("total heat supply");
		getContentPane().add(JLabel6);
		JLabel6.setForeground(java.awt.Color.red);
		JLabel6.setBounds(24,288,156,24);
		getContentPane().add(Q_value);
		Q_value.setForeground(java.awt.Color.red);
		Q_value.setBounds(312,288,96,24);
		Q_value.setSelectionColor(new java.awt.Color(204,204,255));
		Q_value.setSelectedTextColor(java.awt.Color.black);
		Q_value.setCaretColor(java.awt.Color.black);
		Q_value.setDisabledTextColor(java.awt.Color.lightGray);
		JLabel4.setText("efficiency");
		getContentPane().add(JLabel4);
		JLabel4.setForeground(java.awt.Color.red);
		JLabel4.setBounds(492,252,156,24);
		eta_value.setSelectionColor(new java.awt.Color(204,204,255));
		eta_value.setSelectedTextColor(java.awt.Color.black);
		eta_value.setCaretColor(java.awt.Color.black);
		eta_value.setDisabledTextColor(java.awt.Color.lightGray);
		getContentPane().add(eta_value);
		eta_value.setForeground(java.awt.Color.red);
		eta_value.setBounds(480,288,96,24);
		bCalculate.setText("Calculate ");
		bCalculate.setActionCommand("Calculate ");
		getContentPane().add(bCalculate);
		bCalculate.setBounds(468,96,156,60);
		JLabel10.setText("solar Stirling energy balance");
		getContentPane().add(JLabel10);
		JLabel10.setForeground(java.awt.Color.blue);
		JLabel10.setFont(new Font("Dialog", Font.BOLD, 24));
		JLabel10.setBounds(156,36,384,24);
		JLabel5.setText("power");
		getContentPane().add(JLabel5);
		JLabel5.setForeground(java.awt.Color.blue);
		JLabel5.setFont(new Font("Dialog", Font.BOLD, 16));
		JLabel5.setBounds(216,84,108,24);
		JLabel7.setText("heat");
		getContentPane().add(JLabel7);
		JLabel7.setForeground(java.awt.Color.blue);
		JLabel7.setFont(new Font("Dialog", Font.BOLD, 16));
		JLabel7.setBounds(336,84,108,24);
		expanHeat_value.setSelectionColor(new java.awt.Color(204,204,255));
		expanHeat_value.setSelectedTextColor(java.awt.Color.black);
		expanHeat_value.setCaretColor(java.awt.Color.black);
		expanHeat_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		getContentPane().add(expanHeat_value);
		expanHeat_value.setBounds(312,144,96,24);
		comprHeat_value.setSelectionColor(new java.awt.Color(204,204,255));
		comprHeat_value.setSelectedTextColor(java.awt.Color.black);
		comprHeat_value.setCaretColor(java.awt.Color.black);
		comprHeat_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		getContentPane().add(comprHeat_value);
		comprHeat_value.setBounds(312,108,96,24);
		JLabel8.setText("solar collector");
		getContentPane().add(JLabel8);
		JLabel8.setBounds(24,180,156,24);
		solarHeat_value.setSelectionColor(new java.awt.Color(204,204,255));
		solarHeat_value.setSelectedTextColor(java.awt.Color.black);
		solarHeat_value.setCaretColor(java.awt.Color.black);
		solarHeat_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		getContentPane().add(solarHeat_value);
		solarHeat_value.setBounds(312,180,96,24);
		JLabel9.setText("external cooling");
		getContentPane().add(JLabel9);
		JLabel9.setBounds(24,216,156,24);
		extCooling_value.setSelectionColor(new java.awt.Color(204,204,255));
		extCooling_value.setSelectedTextColor(java.awt.Color.black);
		extCooling_value.setCaretColor(java.awt.Color.black);
		extCooling_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		getContentPane().add(extCooling_value);
		extCooling_value.setBounds(312,216,96,24);
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		bCalculate.addActionListener(lSymAction);
		//}}

		//{{INIT_MENUS
		//}}

		type="stirling";
	}

	public String getClassDescription(){
	    return "pilot for a simple Stirling motor\n\nauthor : R. Gicquel february 2008";
	}

	public void setVisible(boolean b)
	{
		if(b)
		{
			setLocation(50, 50);
		}
	super.setVisible(b);
	}

	public void addNotify()
	{
		// Record the size of the window prior to calling parents addNotify.
		Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		Insets ins = getInsets();
		setSize(ins.left + ins.right + d.width, ins.top + ins.bottom + d.height);
		Component components[] = getContentPane().getComponents();
		for (int i = 0; i < components.length; i++)
			{
			Point p = components[i].getLocation();
			p.translate(ins.left, ins.top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

	// Used for addNotify check.
	boolean fComponentsAdjusted = false;

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
		Object object = event.getSource();
		if (object == PiloteStirling.this)
			PiloteStirling_WindowClosing(event);
		}
	}

	void PiloteStirling_WindowClosing(java.awt.event.WindowEvent event)
	{
		dispose();		 // dispose of the Frame.
	}
	//{{DECLARE_CONTROLS
	javax.swing.JLabel JLabel1 = new javax.swing.JLabel();
	javax.swing.JTextField tauCompr_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel2 = new javax.swing.JLabel();
	javax.swing.JTextField tauExpan_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel3 = new javax.swing.JLabel();
	javax.swing.JTextField netPower_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel6 = new javax.swing.JLabel();
	javax.swing.JTextField Q_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel4 = new javax.swing.JLabel();
	javax.swing.JTextField eta_value = new javax.swing.JTextField();
	javax.swing.JButton bCalculate = new javax.swing.JButton();
	javax.swing.JLabel JLabel10 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel5 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel7 = new javax.swing.JLabel();
	javax.swing.JTextField expanHeat_value = new javax.swing.JTextField();
	javax.swing.JTextField comprHeat_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel8 = new javax.swing.JLabel();
	javax.swing.JTextField solarHeat_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel9 = new javax.swing.JLabel();
	javax.swing.JTextField extCooling_value = new javax.swing.JTextField();
	//}}

	//{{DECLARE_MENUS
	//}}


	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == bCalculate)
				bCalculate_actionPerformed(event);
		}
	}	

		public void init(){
		isInitialized=true;
		proj=getProjet();
		setupProject();
		//On rcupre la liste et le type des composants prsents dans l'diteur de schmas
		//Retrieves the list and the type of components in the diagram editor
		String[]listComp=proj.getEditorComponentList();
		composant=new String[listComp.length];
		nomComposant=new String[listComp.length];
		
		//on en extrait les noms des transfos de compression et de dtente
		//gets the names of compression et expansion processes
        for(int i=0;i<listComp.length;i++){
		    composant[i]=Util.extr_value(listComp[i], "type");
		    nomComposant[i]=Util.extr_value(listComp[i], "name");
		    if(composant[i].equals("Compression"))compressorName=nomComposant[i];
		    if(composant[i].equals("Expansion"))expansionName=nomComposant[i];
        }
        //test de cohrence (des messages d'erreur plus prcis seraient souhaitables)
        //consistency test (error messages should be an improvement)
        if((!expansionName.equals(""))&&(!compressorName.equals(""))&& isBuilt)isBuilt=true;
		if(isBuilt)setVisible(true);//on n'ouvre le pilote que si sa structure est correcte
		                    //the driver cannot be open if its structure is wrong
	}
	
    
    void setupProject(){
        //on rcupre ici l'instance de la transfo externe du capteur solaire
		//Retrieves the instances of the solar collector external class
        Vector vExt=proj.getExternalClassInstances();//Vector contenant les classes externes
        int j=0;
        for(int i=0;i<vExt.size();i++){
            Object[] obj=new Object[6];
	        obj=(Object[])vExt.elementAt(i);
	        ExtProcess ep=(ExtProcess)obj[1];
	        if(ep instanceof SolarConcentratorCC){
	            collector=(SolarConcentratorCC)ep;
	            collectorName=collector.getName();
	            j++;
	        }
        }
        if(j==1)isBuilt=true;//test de cohrence du pilote par rapport au modle
        //consistency test (error messages should be an improvement)
  }
	
	void bCalculate_actionPerformed(java.awt.event.ActionEvent event){
	    if(!isInitialized)init();//la premire fois, on initialise, car il faut un constructeur sans argument
	                            //pour instancier la classe par le RMI
	                            //the initialization is made during the first call, as the constructor 
	                            //must have no argument because the class is instanciated by the RMI
	    
        String[] args=new String[2];
        args[0]="process";
        args[1]=compressorName;//compression
        Vector vProp=proj.getProperties(args);
        String amont=(String)vProp.elementAt(1);//point amont //inlet point
        String aval=(String)vProp.elementAt(2);//point aval //outlet point
        Double f=(Double)vProp.elementAt(4);
        double deltaUcompr=f.doubleValue();//puissance compresseur //compression power
        f=(Double)vProp.elementAt(12);
        double Qcompr=f.doubleValue();//chaleur compresseur //compressor heat
        
        args[1]=expansionName;//dtente //expansion
        vProp=proj.getProperties(args);
        amont=(String)vProp.elementAt(1);//point amont //inlet point
        aval=(String)vProp.elementAt(2);//point aval //outlet point
        f=(Double)vProp.elementAt(4);
        double deltaUexpan=f.doubleValue();//puissance dtente //expansion power
        f=(Double)vProp.elementAt(12);
        double Qexpan=f.doubleValue();//chaleur dtente //expansion heat
        
        args[1]=collectorName;//capteur solaire //solar collector
        vProp=proj.getProperties(args);
        f=(Double)vProp.elementAt(4);
        double solarHeat=f.doubleValue();//chaleur solaire //solar heat
                    
	    //calcul des performances globales du moteur et affichages
	    //calculates the overall motor energies and displays them on the driver screen
        tauExpan_value.setText(Util.aff_d(deltaUexpan, 3));
        netPower_value.setText(Util.aff_d(deltaUexpan+deltaUcompr, 3));
        tauCompr_value.setText(Util.aff_d(deltaUcompr, 3));
	    Q_value.setText(Util.aff_d(Qexpan+solarHeat, 3));
	    eta_value.setText(Util.aff_d((-deltaUexpan-deltaUcompr)/(Qexpan+solarHeat), 3));
	    expanHeat_value.setText(Util.aff_d(Qexpan, 3));
	    comprHeat_value.setText(Util.aff_d(Qcompr, 3));
	    solarHeat_value.setText(Util.aff_d(solarHeat, 3));
	    extCooling_value.setText(Util.aff_d(-(Qexpan+solarHeat+deltaUexpan+deltaUcompr+Qcompr), 3));
	    
	    System.out.println("compr\tdetente\tsolaire\t");
	    System.out.println(deltaUcompr+"\t"+deltaUexpan+"\t");
	    System.out.println(Qcompr+"\t"+Qexpan+"\t"+solarHeat);
	}
}